# coding: utf-8
import wx
import math
import frmThebault

class frmThebaultMyFrame1(frmThebault.MyFrame1):
    def __init__(self, parent):
        frmThebault.MyFrame1.__init__(self, parent)

    def CheckAndGetTextfield(self, TextField, ReturnNum = 'INT'):
        txt = TextField.Value
        if not txt.isnumeric():
            wx.MessageBox(u'ここには正の整数を書き込んでください。')
            return False
        if ReturnNum == 'INT':
            return int(txt)
        else:
            t = [int(i) for i in txt.strip()]
            t.reverse()
            return t

    #---------------------------------------------------------------------- page31　ここから







    # Handlers for MyFrame1 events.
    def OnBtnN1p31(self, event):

        def BaseBmakeSqure(lstN, Bfrom=2, Bto=1000000):
            """
            底が b の数 N1 が平方数となる底を Bfrom からBtoまで調べる
            :param lstN: [d0,d1,d2,....dn] 各位の数字のリスト（逆順）
            :param Bfrom: 開始の底 b
            :param Bto: 調べる底の上限
            :return: 現在は、リストボックスに結果を表示する。以下のものも用意しておく
                     平方となる底が見つかった時 [b 、１０審表記のN、見つかった時 N の平方根１
                     見つからなかった時は  [-1]
            """

            d, bMax, bFlag = len(lstN), max(lstN), False
            if (bMax + 1) > Bfrom:
                b = bMax + 1
            else:
                b = Bfrom


            while b <= Bto:
                bb, N = 1, 0
                for i in lstN:
                    N += i * bb
                    bb *= b
                irN = int(math.sqrt(N))
                if N == irN * irN:
                    bFlag = True

                    self.lsbAns12p31.Append('b=' + str(b) + u' のとき、N=' + str(N) + u'　、　' + str(irN) + u'の平方数')


                b += 1

            if bFlag == False:
                self.lsbAns12p31.Append(u'底 b が、' + str(Bto) + u' まででは平方数とはならない')


        bUpLimit = self.CheckAndGetTextfield(self.txtBp31,'INT')
        if bUpLimit == False:
            return
        lN = self.CheckAndGetTextfield(self.txtN1p31,'LIST')
        if lN == False:
            return
        self.lsbAns12p31.Clear()

        BaseBmakeSqure(lN,2,bUpLimit)


    def OnBtnN2p31(self, event):

        def BaseBmake4thSqure(lstN, Bfrom=2, Bto=1000000):
            """
            底が b の数 N1 が４乗数となる底を Bfrom からBtoまで調べる
            :param lstN: [d0,d1,d2,....dn] 各位の数字のリスト（逆順）
            :param Bfrom: 開始の底 b
            :param Bto: 調べる底の上限
            :return: 現在は、リストボックスに結果を表示する。以下のものも用意しておく
                     平方となる底が見つかった時 [b 、１０審表記のN、見つかった時 N の平方根１
                     見つからなかった時は  [-1]
            """
            d, bMax, bFlag = len(lstN), max(lstN), False
            if (bMax + 1) > Bfrom:
                b = bMax + 1
            else:
                b = Bfrom
            while b <= Bto:
                bb, N = 1, 0
                for i in lstN:
                    N += i * bb
                    bb *= b

                ir4N = int(math.sqrt(math.sqrt(N)))
                if N == ir4N * ir4N * ir4N * ir4N:
                    bFlag = True
                    self.lsbAns12p31.Append( \
                        'b=' + str(b) + u' のとき、N=' + str(N) + u'　、　' + str(ir4N) + u'の４乗数')

                b += 1

            if bFlag == False:
                self.lsbAns12p31.Append(u'底 b が、' + str(Bto) + u' まででは４乗数とはならない')


        bUpLimit = self.CheckAndGetTextfield(self.txtBp31, 'INT')
        if bUpLimit == False:
            return
        lN = self.CheckAndGetTextfield(self.txtN2p31, 'LIST')
        if lN == False:
            return
        self.lsbAns12p31.Clear()
        BaseBmake4thSqure(lN, 2, bUpLimit)

    def OnBtnN3p31(self, event):
        # TODO: Implement OnBtnN3p31
        """
         11)底が10の時でも5の時でも平方数である６桁の数
         :param LimitN:
         :return:
         """

        def genB10Bb(n=5, r=6, x=[]):  # 異なるn種類のものから重複を許してr個取り出してできる順列

            if x == []:
                x = [r for i in range(n + 1)]
            x[0:0] = [1]
            x = x + [0]

            p = [0 for i in range(r + 1)]
            k = 0
            while True:

                while k < r and x[p[k]] > 0:
                    x[p[k]] = x[p[k]] - 1
                    k += 1
                    p[k] = 1

                if k == r and x[p[k]] > 0:
                    N10, Nb = 0, 0
                    for i in p[1:]:
                        N10, Nb = N10 * 10 + (i - 1), Nb * n + (i - 1)
                    yield [N10, Nb, p[1:]]
                    # yield (p[1:])

                while p[k] == n:
                    k -= 1
                    x[p[k]] = x[p[k]] + 1

                p[k] = p[k] + 1

                if k == 0:
                    return


        bUpLimit = self.CheckAndGetTextfield(self.txtBp31, 'INT')
        if bUpLimit == False:
            return
        if bUpLimit > 9:
            ret = wx.MessageBox(u'底 b は、9以下です。上限を９にします。', caption= u'底の上限',
                                style = wx.YES_NO | wx.ICON_QUESTION)
            if ret == wx.NO:
                return
            self.txtBp31.Value = '9'


        k = self.CheckAndGetTextfield(self.txtKp31, 'INT')
        if k == False:
            return
        if k > 5:
            ret = wx.MessageBox(u'桁数( k )が６以上では、計算時間が長くなります。計算しますか？', style=wx.YES_NO | wx.ICON_QUESTION)
            if ret == wx.NO:
                return
        self.lsbAns12p31.Clear()

        b, loopFlag, sLimitN, LimitN = 2, True, 10**(k-1), 10**k
        while b <= bUpLimit:
            for B10Bb in genB10Bb(n=b, r=k):
                B10, Bb, L = B10Bb[0], B10Bb[1], B10Bb[2]
                if B10 > LimitN:
                    break
                if B10 > sLimitN:

                    B10r, Bbr = int(math.sqrt(B10)), int(math.sqrt(Bb))
                    if (B10 == B10r * B10r) and (Bb == Bbr * Bbr):
                        self.lsbAns12p31.Append('(' + str(B10) + ')10 = ' + str(B10r) + '**2  , ' +
                                                  '(' + str(B10) + ')' + str(b) + '  =' + str(Bbr) + '**2')
            b += 1

        if self.lsbAns12p31.GetCount() < 1:
            self.lsbAns12p31.Append(str(LimitN) + u' までには見つかりませんでした')



        #---------------------------------------------------------------------- page31 ここまで

    #---------------------------------------------------------------------- page33  ここから

    def OnBtnCp33(self, event):
        LimitNp33 = self.CheckAndGetTextfield(self.txtLimitNp33)
        if LimitNp33 == False:
            return 
        pn = self.rdbPp33.GetSelection() +1
        if pn == 1:
            self.P1(LimitNp33)
        elif pn == 2:
            self.P2(LimitNp33)
        elif pn == 3:
            self.P3(LimitNp33)
        elif pn == 4:
            self.P4(LimitNp33)
        elif pn == 5:
            self.P5(LimitNp33)
        elif pn == 6:
            self.P6(LimitNp33)
        elif pn == 7:
            self.P7(LimitNp33)
        elif pn == 8:
            self.P8(LimitNp33)
        elif pn == 9:
            self.P9(LimitNp33)
        elif pn == 10:
            self.P10(LimitNp33)
        elif pn == 11:
            self.P11(LimitNp33)



    def  P1(self, LimitN = 1000000):
        """
        1)最後の３桁に０以外の数が並ぶ平方数
        """
        self.lsbAnsp33.Clear()
        d3 = [111, 222, 333, 444, 555, 666, 777, 888, 999]
        n = 0
        while n < LimitN:
            for i3 in d3:
                nn = n + i3
                nr = int(math.sqrt(nn))
                if nn == (nr*nr):
                    self.lsbAnsp33.Append(str(nn)+ ' = ' + str(nr) + '**2')
            n += 1000
        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')

    def SearchInPerOrCombi(self,genF, r, LimitN, Nmax):

        self.lsbAnsp33.Clear()

        if LimitN > Nmax:
            LimitN = Nmax
        loopFlag = True
        while loopFlag and r < 10:
            r += 1
            for n in genF(r):
                if n > LimitN:
                    loopFlag = False
                    break
                nr = int(math.sqrt(n))
                if n == (nr * nr):
                    self.lsbAnsp33.Append(str(n) + ' = ' + str(nr) + '**2')

        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')

    def  P2(self, LimitN = 1000000):
        """
        2)下の桁ほど数が大きくなる平方数
        :param LimitN:
        :return:
        """
        def  genNascend(r):
            """
            generate N ... each digits are ascending

            :param r:r digits
            :return:N
            """
            n = 10 # 0,1,2,...9 number
            c = [0 for i in range(n + 1)]
            c[0], c[1], k = -1, 1, 1
            while k > 0:
                for i in range(k + 1, r + 1):
                    c[i] = c[i - 1] + 1
                if c[1] > 1:
                    N = 0
                    for ci in c[1:r+1]:
                        N = N * 10 + ci-1
                    yield N    #-----------

                k = r
                while c[k] == (n - r + k):
                    k -= 1
                c[k] = c[k] + 1

        self.SearchInPerOrCombi(genNascend, 1, LimitN, 123456789)


    def  P3(self, LimitN = 1000000):
        """
        3)下の桁ほど数が小さくなる平方数
        :param LimitN:
        :return:
        """

        def genNdescend(r):
            """
            generate N ... each digits are ascending

            :param r:r digits
            :return:N
            """
            n = 10  # 0,1,2,...9 number
            c = [0 for i in range(n + 1)]
            c[0], c[1], k = -1, 1, 1

            while k > 0:
                for i in range(k + 1, r + 1):
                    c[i] = c[i - 1] + 1
                N = 0
                for ci in range(r,0, -1):
                    N = N * 10 + c[ci]

                yield N

                k = r
                while c[k] == (n - r + k):
                    k -= 1

                c[k] = c[k] + 1

        self.SearchInPerOrCombi(genNdescend, 1, LimitN, 9876543210)




    def  P4(self, LimitN = 1000000):
        """
        4)各桁の数がすべて異なる平方数
        :param LimitN:
        :return:
        """

        def genPermR(r):
            n = 10 #1,2,3,4,...,9,0
            p = [i for i in range(n + 1)]
            k = n + 1
            x = [0 for i in range(n + 2)]
            x[n + 1] = n + 1
            L = []
            while True:
                while k > (n - r + 1):
                    k -= 1
                    x[k] = k

                #yield p[(n - r + 1):]
                N = 0
                for d in p[n-r+1:]:
                    N = N * 10 + d-1
                #yield N
                L.append(N)

                while x[k] == 1:
                    p[k], p[1] = p[1], p[k]
                    k += 1

                if k > n:
                    break

                x[k] = x[k] - 1
                p[x[k]], p[x[k] + 1], p[k] = p[x[k] + 1], p[k], p[x[k]]

            L.sort()
            return L

        self.SearchInPerOrCombi(genPermR, 1, LimitN, 9876543210)





    def  P5(self, LimitN = 1000000):
        """
        5)１から９までの数字を１つずつ持つ平方数
        :param LimitN:
        :return:
        """

        def genPermN9(r):
            p = [i for i in range(9 + 1)]
            k = 9 + 1
            x = [0 for i in range(9 + 2)]
            x[9 + 1] = 9 + 1
            L = []
            while True:

                while k > 1:
                    k -= 1
                    x[k] = k
                N = 0
                for d in p[1:]:
                    N = N * 10 + d
                L.append(N)
                while x[k] == 1:
                    p[k], p[1] = p[1], p[k]
                    k += 1

                if k > 9:
                    break

                x[k] = x[k] - 1
                p[x[k]], p[x[k] + 1], p[k] = p[x[k] + 1], p[k], p[x[k]]
            L.sort()
            return L

        self.SearchInPerOrCombi(genPermN9, 8, LimitN, 987654321)

    def  P6(self, LimitN = 1000000):
        """
        6)最後の４桁が６５１６である平方数"
        :param LimitN:
        :return:
        """
        self.lsbAnsp33.Clear()

        n = 6516
        while n < LimitN:
            nr = int(math.sqrt(n))
            if n == (nr * nr):
                self.lsbAnsp33.Append(str(n) + ' = ' + str(nr) + '**2')
            n += 10000
        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')

    def  P7(self, LimitN = 1000000):
        """
        7)ＡＢＢＡの形をした正の整数で１を加えると平方数となる数
        :param LimitN:
        :return:
        """
        self.lsbAnsp33.Clear()

        Ul = 10**(len(str(LimitN))//2)

        for a in range(1, Ul):
            ka = len(str(a))
            for b in range(Ul):
                kb = len(str(b))
                n = (a*(10**kb) + b)*(10**(ka+kb)) + (b*(10**ka) + a)
                if n > LimitN:
                    break
                nr = int(math.sqrt(n+1))
                if (n + 1) == (nr * nr):
                    self.lsbAnsp33.Append(str(a) + ' ' + str(b) + ' ' + str(b) + ' ' + str(a) + ' + 1  = '
                                          + str(n+1) + ' = '+ str(nr) + '**2')

        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')

    def  P8(self, LimitN = 1000000):
        """
        8)各桁の数の合計が平方数のものと同じ数
        :param LimitN:
        :return:
        """
        def sum_d(n):
            s = 0
            while n>0:
                n, d = n//10, n%10
                s += d
            return s

        self.lsbAnsp33.Clear()

        x = 1
        while x < LimitN:
            if sum_d(x) == sum_d(x*x):
                self.lsbAnsp33.Append(str(x) + ' , ' + str(x) + '**2=' + str(x*x)
                                      + u' : 各桁の数字の和 = ' + str(sum_d(x)))
            x += 1
        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')


    def  P9(self, LimitN = 1000000):
        """
        9)各桁の数の合計が９になる平方数
        :param LimitN:
        :return:
        """

        def genN9():
            for i1 in range(9 + 1):
                # N, s =i1, i1
                for i2 in range(9 - i1 + 1):
                    # N, s = N*10 +i2, s+i2
                    for i3 in range(9 - i1 - i2 + 1):
                        # N, s = N*10 +i3, s+i3
                        for i4 in range(9 - i1 - i2 - i3 + 1):
                            # N, s = N*10 + i4, s+i4
                            for i5 in range(9 - i1 - i2 - i3 - i4 + 1):
                                # N, s = N*10 + i5, s+i5
                                for i6 in range(9 - i1 - i2 - i3 - i4 - i5 + 1):
                                    # N, s = N * 10 + i6, s + i6
                                    for i7 in range(9 - i1 - i2 - i3 - i4 - i5 - i6 + 1):
                                        # N, s = N * 10 + i7, s + i7
                                        for i8 in range(9 - i1 - i2 - i3 - i4 - i5 - i6 - i7 + 1):
                                            N = (9 - i1 - i2 - i3 - i4 - i5 - i6 - i7 - i8) + \
                                                10 * (i8 + 10 * (i7 + 10 * (
                                                i6 + 10 * (i5 + 10 * (i4 + 10 * (i3 + 10 * (i2 + 10 * i1)))))))
                                            yield N

        self.lsbAnsp33.Clear()

        if LimitN > 900000000:
            LimitN = 900000000
        loopFlag = True
        while loopFlag:

            for n in genN9():
                if n > LimitN:
                    loopFlag = False
                    break
                nr = int(math.sqrt(n))
                if n == (nr * nr):
                    self.lsbAnsp33.Append(str(n) + ' = ' + str(nr) + '**2')

        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')

    def  P10(self, LimitN = 1000000):
        """
        10)45が持つ下の条件をもつ数
            条件\n45の平方 = 2025 = (20 + 25)の平方
        :param LimitN:
        :return:
        """
        self.lsbAnsp33.Clear()

        k, loopFlag= 1, True
        while loopFlag:
            kb = 10**k
            for n in range(10**(2*k-1), 10**(2*k)):
                nl, nr = n//kb, n%kb
                nlr, nlr2 = (nl+nr), (nl+nr)**2
                if n > LimitN:
                    loopFlag = False
                    break
                if n == nlr2:
                    self.lsbAnsp33.Append(str(nlr) + '**2=' + str(n)
                                      + ' = (' + str(nl) + ' + ' + str(nr) + ')**2')
            k += 1
        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')



    def  P11(self, LimitN = 1000000):
        """
        11)底が10の時でも5の時でも平方数である６桁の数
        :param LimitN:
        :return:
        """
        def genB10B5(n=5, r=6, x=[]):  # 異なるn種類のものから重複を許してr個取り出してできる順列

            if x == []:
                x = [r for i in range(n + 1)]
            x[0:0] = [1]
            x = x + [0]

            p = [0 for i in range(r + 1)]
            k = 0
            while True:

                while k < r and x[p[k]] > 0:
                    x[p[k]] = x[p[k]] - 1
                    k += 1
                    p[k] = 1

                if k == r and x[p[k]] > 0:
                    N10, N5 = 0, 0
                    for i in p[1:]:
                        N10, N5 = N10*10 +(i-1), N5*5 + (i-1)
                    yield [N10, N5, p[1:]]
                    # yield (p[1:])

                while p[k] == n:
                    k -= 1
                    x[p[k]] = x[p[k]] + 1

                p[k] = p[k] + 1

                if k == 0:
                    return




        self.lsbAnsp33.Clear()

        loopFlag = True
        for B10B5 in genB10B5():
            B10, B5, L = B10B5[0], B10B5[1], B10B5[2]
            if B10 > LimitN:
                break
            if B10 > 100000:
                B10r, B5r = int(math.sqrt(B10)), int(math.sqrt(B5))
                if (B10 == B10r*B10r) and (B5 == B5r*B5r):
                    N = ''.join([str(i-1) for i in L])
                    self.lsbAnsp33.Append('(' +N + ')10 = ' + str(B10r) +'**2  , ' +
                                          '(' + N + ')5  =' + str(B5r) + '**2')

        if self.lsbAnsp33.GetCount() < 1:
            self.lsbAnsp33.Append(str(LimitN) + u' までには見つかりませんでした')



# ---------------------------------------------------------------------- page33 ここまで


if __name__ == '__main__':
    app = wx.App()
    fname = frmThebaultMyFrame1(None)
    fname.Show()
    app.SetTopWindow(fname)
    app.MainLoop()
